#!/bin/sh
echo Start Build
echo Windows
export GOOS=windows
export GOARCH=amd64
export CGO_ENABLED=0
go build -buildvcs=false -ldflags "-w -s" -trimpath -a -o gost.exe

export GOARCH=386
go build -buildvcs=false -ldflags "-w -s" -trimpath -a -o gost_x86.exe

echo Linux
export GOOS=linux
export GOARCH=amd64
go build -buildvcs=false -ldflags "-w -s" -trimpath -a -o gost

export GOARCH=386
go build -buildvcs=false -ldflags "-w -s" -trimpath -a -o gost_x86

echo MacOS
export GOOS=darwin
export GOARCH=amd64
go build -buildvcs=false -ldflags "-w -s" -trimpath -a -o gost_osx

echo Android
export ANDROID_NDK_ROOT=$PWD/../../../android-ndk-r23b
export GOOS=android
export CGO_ENABLED=1
export GOARCH=arm64
export CC=$(find $ANDROID_NDK_ROOT | grep 'aarch64-linux-android23-clang$')
go build -buildvcs=false -ldflags "-s -w" -a -o gost_android_arm64

export GOARCH=arm
export CC=$(find $ANDROID_NDK_ROOT | grep 'armv7a-linux-androideabi23-clang$')
go build -buildvcs=false -ldflags "-s -w" -a -o gost_android_arm

export GOARCH=386
export CC=$(find $ANDROID_NDK_ROOT | grep 'i686-linux-android23-clang$')
go build -buildvcs=false -ldflags "-s -w" -a -o gost_android_x86

export GOARCH=amd64
export CC=$(find $ANDROID_NDK_ROOT | grep 'x86_64-linux-android23-clang$')
go build -buildvcs=false -ldflags "-s -w" -a -o gost_android_x86_64

mkdir -p mybins/arm64-v8a
mkdir -p mybins/armeabi-v7a
mkdir -p mybins/x86
mkdir -p mybins/x86_64

cp gost_android_arm64 mybins/arm64-v8a/libgost.so
cp gost_android_arm mybins/armeabi-v7a/libgost.so
cp gost_android_x86 mybins/x86/libgost.so
cp gost_android_x86_64 mybins/x86_64/libgost.so